<?php

namespace demo\Controllers;

use Silex\Application;

/**
 * Class EscapeController demonstrates escaping for HTML and JSON.
 *
 * @package demo\Controllers
 */
class EscapeController {

  public function html($name, Application $app) {
    return $app->escape("Hello, $name");
  }

  public function json($name, Application $app) {
    return $app->json(['name' => $name]);
  }
}
