<?php

namespace demo;

use Psr\Log\LoggerInterface;
use Psr\Log\LoggerTrait;

class Logger implements LoggerInterface {

  use LoggerTrait;

  public function __construct() {
    $this->fp = fopen('php://stderr', 'a');
  }

  /**
   * {@inheritdoc}
   */
  public function log($level, $message, array $context = []) {
    fputs($this->fp, "$level: $message\n");
    fflush($this->fp);
  }
}
