<?php

namespace demo\Middleware;

use Silex\Application;
use Symfony\Component\HttpFoundation\Request;

class BeforeAll {

  /**
   * Arguments for before() middleware are fixed, unlike those of controllers.
   *
   * @param \Symfony\Component\HttpFoundation\Request $request
   * @param \Silex\Application $app
   */
  public function next(Request $request, Application $app) {
    // Only add info on requests URIs containing "json".
    if (!preg_match('/json/', $request->getRequestUri())) {
      echo "<p>In bAM</p>\n";
    }
  }

}
